> ## Documentation Index
> Fetch the complete documentation index at: https://docs.godiligent.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Add Document

> Add supporting documents to a CDD case



## OpenAPI

````yaml POST /cdds/{id}/documents
openapi: 3.0.1
info:
  version: 1.5.0
  title: Diligent
  description: >
    Download Postman collection
    [here](https://docs.godiligent.ai/files/postman_collection.json).
servers:
  - url: https://api.godiligent.ai
    description: Production
  - url: https://api.sandbox.godiligent.ai
    description: Sandbox
security:
  - xApiKey: []
tags:
  - name: CDD
    description: Customer Due Diligence
  - name: Company
    description: Company Information
  - name: Blocked Companies
    description: Manage blocked companies
  - name: Monitorings
    description: Website monitoring and alerts for changes and risks
  - name: Webhooks
    description: >

      ## How to Secure Webhook Deliveries

      To ensure that webhook payloads are securely transmitted and verified.
      This guide explains how to configure and validate

      webhook deliveries using a shared secret.


      ### How It Works


      When setting up a webhook, a secret is configured on both the sender (our
      system) and the receiver (your endpoint). Each

      webhook payload is signed using this secret, allowing the receiver to
      verify its authenticity.


      #### Step 1: Configuring Your Webhook Secret


      1. When creating a webhook in our system, specify a unique secret key.
      This secret should be a strong, randomly

      generated string.

      2. Store this secret securely on your server; it should never be exposed
      publicly.


      #### Step 2: Receiving Webhook Payloads


      When your server receives a webhook event, the request will include an
      `X-Signature` header containing a HMAC signature

      of the payload.


      Example header:


      ```

      X-Signature: sha256=abcdef1234567890...

      ```


      #### Step 3: Validating the Webhook Signature


      To verify the webhook payload:


      1. Retrieve the `X-Signature` value from the request headers.

      2. Compute the HMAC SHA-256 signature of the request payload using your
      webhook secret.

      3. Compare the computed signature with the one in the `X-Signature`
      header.

      4. If they match, the webhook is valid.


      #### (Python)


      ```python

      import hashlib

      import hmac

      import json


      def verify_webhook_signature(secret, payload, signature):
        computed_signature = hmac.new(secret.encode(), payload.encode(), hashlib.sha256).hexdigest()
        expected_signature = f"sha256={computed_signature}"
        return hmac.compare_digest(expected_signature, signature)

      # Example usage:

      secret = "your_webhook_secret"

      payload = json.dumps({"event": "example"})

      received_signature = "sha256=abcdef1234567890..."


      if verify_webhook_signature(secret, payload, received_signature):
        print("Valid webhook received!")
      else:
        print("Invalid webhook signature!")
      ```


      #### (JavaScript)


      ```javascript

      const crypto = require('crypto');


      function verifyWebhookSignature (secret, payload, signature) {

      const computedSignature = `sha256=${crypto.createHmac('sha256', secret)

      .update(payload)

      .digest('hex')}`;

      return crypto.timingSafeEqual(Buffer.from(computedSignature),
      Buffer.from(signature));

      }


      // Example usage:

      const secret = "your_webhook_secret";

      const payload = JSON.stringify({ event: "example" });

      const receivedSignature = "sha256=abcdef1234567890...";


      if (verifyWebhookSignature(secret, payload, receivedSignature)) {

      console.log("Valid webhook received!");

      } else {

      console.log("Invalid webhook signature!");

      }

      ```


      #### Security Considerations


      - Always use HTTPS to prevent interception of webhook payloads.

      - Reject webhook requests that fail signature validation.

      - Rotate secrets periodically to enhance security.


      By following this guide, you ensure that webhook deliveries are secure and
      trusted.
  - name: Instant Screening (experimental)
    description: Instant Website Screening API
  - name: Name Screening
    description: Name screening search, alert management and remediation
paths:
  /cdds/{id}/documents:
    post:
      tags:
        - CDD
      summary: Add document to CDD
      description: Add document to CDD
      parameters:
        - name: id
          in: path
          description: The id of the cdd request
          required: true
          schema:
            type: string
            example: d6e3b214-30b1-4401-a1b8-a1bd3c6a84e4
      requestBody:
        content:
          multipart/form-data:
            schema:
              required:
                - type
                - file
              properties:
                type:
                  type: string
                  description: The type of the document
                  enum:
                    - PROOF_OF_ADDRESS
                    - SHAREHOLDERS_LIST
                    - ARTICLES_OF_INCORPORATION
                  example: PROOF_OF_ADDRESS
                file:
                  type: string
                  format: binary
                  description: The file to upload
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Document'
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
        '403':
          description: Forbidden
        '404':
          description: Not found
        '500':
          description: Internal Server Error
      security:
        - xApiKey: []
components:
  schemas:
    Document:
      type: object
      properties:
        id:
          type: string
          description: The id of the document
          example: doc_123
        created_at:
          type: string
          format: ISO8601
          description: The date the document was created
          example: '2023-04-30T23:50:51.222Z'
        file_name:
          type: string
          description: The name of the document
          example: proof_of_address.pdf
        file_type:
          type: string
          description: mime type of the file
          enum:
            - application/pdf
          example: application/pdf
        type:
          type: string
          description: The type of the document
          enum:
            - CHRONOLOGICAL_EXTRACT
            - SHAREHOLDER_LIST
            - REGISTRY_EXCERPT
            - INCORPORATION
            - OWNERSHIP_AND_SHAREHOLDING_CHANGES
            - OFFICER_CHANGES
            - FINANCIAL_STATEMENTS
            - ADDRESS_AND_STRUCTURAL_CHANGES
          example: INCORPORATION
        url:
          type: string
          description: The URL to download the document
          example: >-
            https://example-bucket.s3.eu-central-1.amazonaws.com/placeholder-folder/sample-document.pdf
  securitySchemes:
    xApiKey:
      type: apiKey
      name: X-API-KEY
      in: header

````